# coding: utf-8


class BasePattern(object):
    display_limit = 20

    def set_display_limit(self, display_limit):
        self.display_limit = display_limit
        return self

    def add_callback(self, callback):
        """
        add callback function.
        :param callback: callback function. if callback is None, not add callback.
        :return: self(pattern).
        """
        if not hasattr(self, 'callbacks'):
            self.callbacks = []
        if callback:
            self.callbacks.append(callback)
        return self

